
LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.NUMERIC_STD.ALL;



ENTITY ExternalBoard IS
 
   PORT(
      ul_Clk_i               : IN  STD_ULOGIC;  -- Clock
      ul_Rst_i               : IN  STD_ULOGIC;  -- Reset (1 = reset)
   
      ul_Start_o             : IN  STD_ULOGIC;                       
      ulv32_Data_o           : OUT STD_ULOGIC_VECTOR(31 DOWNTO 0);  
      ulv32_Addr_i           : IN  STD_ULOGIC_VECTOR(31 DOWNTO 0);  
      ulv32_Test_i           : IN  STD_ULOGIC_VECTOR(31 DOWNTO 0);  
      ulv32_Test1_i          : IN  STD_ULOGIC_VECTOR(31 DOWNTO 0) 
   );

END ExternalBoard;

ARCHITECTURE a_ExternalBoard OF ExternalBoard IS

   COMPONENT e_FlipFlop IS                                           
   PORT 
   (
      ul_Clk_i                   :IN STD_ULOGIC;                                                                                            
      ul_Rst_i                   :IN STD_ULOGIC;                                                                                                                                                                                                           
      ulv32_DataIn_i             :IN STD_ULOGIC_VECTOR(31 DOWNTO 0);                       
      ulv32_DataOut_o            :OUT STD_ULOGIC_VECTOR(31 DOWNTO 0)                                                                                                                                                
   );                                                                                                                                               
   END COMPONENT e_FlipFlop;
   
   SIGNAL ulv32_AddrFF_s : STD_ULOGIC_VECTOR(31 DOWNTO 0);
  
   
BEGIN

   FlipFlop: e_FlipFlop                                           
   PORT MAP 
   (
      ul_Clk_i                   => ul_Clk_i,                                                                       
      ul_Rst_i                   => ul_Rst_i,                                                                                                                                                                                       
      ulv32_DataIn_i             => ulv32_Addr_i,                       
      ulv32_DataOut_o            => ulv32_AddrFF_s                                                                                                                                                
   );                                                                                                                                               
   
   
   
   
   pProcess : PROCESS
   BEGIN
      
      IF(ul_Rst_i = '1') THEN
      
      ELSIF(RISING_EDGE(ul_Clk_i)) THEN
         
         IF(ul_Start_o = '1') THEN
            
           ulv32_Data_o <= (ulv32_Test_i XOR ulv32_Test1_i) AND ulv32_AddrFF_s;
         
         ELSE
         
            ulv32_Data_o <= x"0000_FFFF";
            
         END IF;
         
      END IF;
    
   END PROCESS pProcess;

  
   
END;