
LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.NUMERIC_STD.ALL;
USE IEEE.MATH_REAL.LOG2;

ENTITY e_FlipFlop IS

	 PORT 
   (
      ul_Clk_i                   :IN STD_ULOGIC;                                                                                            
      ul_Rst_i                   :IN STD_ULOGIC;                                                                                                                                                                                                           
      ulv32_DataIn_i             :IN STD_ULOGIC_VECTOR(31 DOWNTO 0);                       
      ulv32_DataOut_o            :OUT STD_ULOGIC_VECTOR(31 DOWNTO 0)                                                                                                                                                
   );     
END e_FlipFlop;

ARCHITECTURE a_FlipFlop OF e_FlipFlop IS
   
   SIGNAL ulv32_DD_s : STD_ULOGIC_VECTOR(31 DOWNTO 0);
   
BEGIN

	p_Process: 
   PROCESS(ul_Clk_i, ul_Rst_i)

	BEGIN
      IF(ul_Rst_i = '1') THEN
         ulv32_DataOut_o <= (OTHERS => '0');
         ulv32_DD_s      <= (OTHERS => '0');
		ELSIF(RISING_EDGE(ul_Clk_i)) THEN
      
         ulv32_DD_s <= ulv32_DataIn_i;
         ulv32_DataOut_o <= ulv32_DD_s;
         
		END IF;
	END PROCESS;
		
END ARCHITECTURE a_FlipFlop;